-- ******************************** Variables *******************************
local L = LibStub("AceLocale-3.0"):GetLocale("Titan", true)
local LB = LibStub("AceLocale-3.0"):GetLocale("TitanPals", true)
-- ******************************** Functions *******************************

-- **************************************************************************
-- NAME : TitanPanelPalsButton_SetTooltipText()
-- DESC : Build Firends Tooltip for Titan Panel
-- **************************************************************************
function TitanPanelPalsButton_SetTooltip()
     GameTooltip:SetText(LB["TITAN_PALS_TOOLTIP"], HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);
     local np = GetNumFriends();
     local op = 0;
     local ofI, opn, opl, opc, opa, opco, ops, opno, tpcnp, tpai;

     if ( np == 0 ) then
          GameTooltip:AddLine("Your Pals List Is Currently Empty!!!")
     else
          -- For showing online friends
          for ofI=1, np do
               opn, opl, opc, opa, opco, ops, opno = GetFriendInfo(ofI);
               if ( opco ) then
                    --TitanPanelPals_UpdatePals(OnlinePals_name, OnlinePals_level, OnlinePals_class, OnlinePals_area, OnlinePals_note);
                    tpcnp = TitanPanelPals_CoreUtils("NamePlate", ops, opl, opc, opn);
                    tpai = opa;
                    op = op + 1;
                    if ( TitanPals["ShowNote"] ) then
                         if ( opno ) then opno = "("..opno..")"; tpai = TitanPanelPals_ColorUtils("GetCText", "gray", opno).." "..tpai; end
                    end
                    GameTooltip:AddDoubleLine(tpcnp, TitanPanelPals_ColorUtils("GetCText", "hlight", tpai));
                    tpcnp = ""; tpai = "";
	       end
          end
          if ( op == 0 ) then GameTooltip:AddLine("No Pals Currently Online"); end
          -- For showing offline friends  
          if ( TitanPals["ShowOffline"] ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_OFF"]));
               for ofI=1, np do
                    opn, opl, opc, opa, opco, ops, opno = GetFriendInfo(ofI);
                    tpcnp = TitanPanelPals_CoreUtils("NamePlate", ops, opl, opc, opn);
                    tpai = "<Offline>"
                    if ( TitanPals["ShowNote"] and opno ) then tpai = TitanPanelPals_ColorUtils("GetCText", "gray", "("..opno..")")..tpai end
                    if ( not opco ) then
		         local altFind = TitanPanelPals_CoreUtils("altFind", opn)
                         if ( TitanPals["NoAlts"] and not altFind ) then
                              GameTooltip:AddDoubleLine(tpcnp, TitanPanelPals_ColorUtils("GetCText", "gray", tpai));
                         elseif ( not TitanPals["NoAlts"] ) then 
                              GameTooltip:AddDoubleLine(tpcnp, TitanPanelPals_ColorUtils("GetCText", "gray", tpai));
                         end
                    end
               end
          end
	  -- For showing ignored ppl
          if ( TitanPals["ShowIgnored"] ) then
               GameTooltip:AddLine("\n");
               GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_IGNORE"]));
               ni = GetNumIgnores();
               if ( ni == 0 ) then 
	            GameTooltip:AddLine("Your ignore list is currently empty.");
               else
                    for ofI=1, ni do
                         local tpit = TitanPanelPals_ColorUtils("GetCText", "red", "<Ignored>");
                         GameTooltip:AddDoubleLine("  "..TitanPanelPals_ColorUtils("GetCText", "normal", GetIgnoreName(ofI)), tpit);
                    end
               end
          end
     end
     -- For showing AddOn memory Usage
     if ( TitanPals["ShowMem"] ) then
          GameTooltip:AddLine("\n");
          GameTooltip:AddLine(TitanPanelPals_ColorUtils("GetCText", "hlight", LB["TITAN_PALS_TOOLTIP_MEM"]));
	  GameTooltip:AddDoubleLine("Titan Panel [|cffeda55fPals|r]", TitanPanelPals_ColorUtils("GetCText", "green", floor(GetAddOnMemoryUsage('TitanPals')).."kb"))
     end
end

-- **************************************************************************
-- NAME : TitanPanelPals_AddPals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_AddPals(name, level, class, area, note)
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( not TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name] ) then 
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name] = {};
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].name = name;
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].level = level;
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].class = class;
		TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].area = area;
		if ( note ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].note = note; end
	end
end

-- **************************************************************************
-- NAME : TitanPanelPals_UpdatePals()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_UpdatePals(name, level, class, area, note)
	local TitanPalsFaction = UnitFactionGroup("player");
	local TitanPalsRealm = GetCVar("realmName");
	local TitanPalsRealmUnit = GetUnitName("player");
	if ( name ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].name = name; end
	if ( level ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].level = level; end
	if ( class ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].class = class; end
	if ( area ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].area = area; end
	if ( note ) then TitanPals[TitanPalsFaction][TitanPalsRealm][TitanPalsRealmUnit][name].note = note; end
end

-- **************************************************************************
-- NAME : TitanPanelPals_FixPalsEcho()
-- DESC : <research>
-- **************************************************************************
function TitanPanelPals_FixPalsEcho(level, class, name)		
	local class = TitanPalsUtils_ClassToColor("color", class, class)
	local name = TitanPalsUtils_ClassToColor("color", class, name)
	return "Fixing Pals ["..name.."] Class = ["..class.."] Level = ["..TitanPalsUtils_GetColoredText("orange", level).."]";
end

-- **************************************************************************
-- NAME : TitanPalsUtils_FixPal()
-- DESC : <research>
-- **************************************************************************
function TitanPalsUtils_FixPal(PN, PC, PL)
	if ( PC == "1" ) then PC = "Warrior"
	elseif ( PC == "2" ) then PC = "Mage"
	elseif ( PC == "3" ) then PC = "Warlock"
	elseif ( PC == "4" ) then PC = "Paladin"
	elseif ( PC == "5" ) then PC = "Priest"
	elseif ( PC == "6" ) then PC = "Hunter"
	elseif ( PC == "7" ) then PC = "Shaman"
	elseif ( PC == "8" ) then PC = "Rogue"
	elseif ( PC == "9" ) then PC = "Druid"
	elseif ( PC == "10" ) then PC = "Death Knight" end
	local printLine = TitanPanelPals_FixPalsEcho(PL, PC, PN)
	TitanPalsUtils_Print(printLine);
	local TPF = UnitFactionGroup("player");
	local TPR = GetCVar("realmName");
	local TPRU = GetUnitName("player");
	TitanPals[TPF][TPR][TPRU][PN].class = PC
	TitanPals[TPF][TPR][TPRU][PN].level = PL
end